// PGraphics salvestamiseks!!!!!!

import peasy.*;

//--- Declare camera
PeasyCam cam;

//--- Read from file
ReadColorTableClass colorTable;
ReadFileClass filePos;
//ReadFileClass filePos1;

void setup(){
  size(800,600,OPENGL);

  //--- Start galaxy
  filePos = new ReadFileClass("xyz_lum_D.dat", 1.0, ',');

  //--- Read color table
  colorTable = new ReadColorTableClass("CT_04.ct");

  //--- Start camera
  cam = new PeasyCam(this,0,0,0,900);
  cam.setMinimumDistance(0.1);

  frameRate(30);

}

void draw(){

  background(0);
  lights();
  sphereDetail(16,16);
  ambientLight(30,30,30);

    strokeWeight(3);

    rotateX(radians(45));
    rotateZ(radians(-30));
    rotateY(radians(6.5));

    for (int i =0; i< filePos.nPoints; i++){
      fill(colorTable.r[constrain(int(filePos.D[i]),0,255)],
           colorTable.g[constrain(int(filePos.D[i]),0,255)],
           colorTable.b[constrain(int(filePos.D[i]),0,255)], 255);
      pushMatrix();
      scale(-1,1,1);
      translate(filePos.x[i], filePos.y[i], filePos.z[i]);
      sphere(filePos.s[i]);
      popMatrix();
    }//--- endfor


  ejes();
  polarGrid();
  //saveFrame("NGC3363-####.png");


} //--- end draw()


//-----------------------------
//
//-----------------------------

/*
void ejes(){
  stroke(255,100,100);
  line(0,0,0, 100,0,0);
  stroke(100,255,100);
  line(0,0,0, 0,100,0);
  stroke(100,100,255);
  line(0,0,0, 0,0,100);
}
*/
void ejes(){
  stroke(255,100,100);
  line(-200,-320,0, 200,-320,0);
  stroke(100,255,100);
  line(0,-320,0, 0,-120,0);
  stroke(100,100,255);
  line(0,-320,-200, 0,-320,200);
}


void polarGrid(){

  float y0 = -320;
  float Radius0 = 110;
  float dRadius = 90;
  int rSteps = 6;
  for (int i =0; i< rSteps; i++){
    drawArc(0,y0, i*dRadius + Radius0);
  }

  int nSteps = 6;
  float dTheta = 120.0/nSteps;
  float Theta0 = 90 - 60;
  stroke(100,100, 150);
  beginShape(LINES);
  for (int i=0; i<=nSteps; i++){
    float xi = Radius0 * cos(radians(i*dTheta+Theta0)) + 0;
    float yi = Radius0 * sin(radians(i*dTheta+Theta0)) + y0;
    float xf = (Radius0 + (rSteps-1) * dRadius) * cos(radians(i*dTheta+Theta0)) + 0;
    float yf = (Radius0 + (rSteps-1) * dRadius) * sin(radians(i*dTheta+Theta0)) + y0;
  vertex(xi,yi, 0);
  vertex(xf,yf, 0);
  }
  endShape();
  noStroke();

  PFont f;  
  f = loadFont("URWBookmanL-Ligh-24.vlw");
  textFont(f);
  fill(255,255,255,255);
//  text("0", 0,-320+600,0);

}

void drawArc(float _x0, float _y0, float _radius){
  int nSteps = 36;
  float dTheta = 120.0/nSteps;
  float Theta0 = 90 - 60;

  stroke(100,100, 150);
  beginShape(LINES);
  for (int i=0; i<nSteps; i++){

    float xi = _radius * cos(radians(i*dTheta+Theta0)) + _x0;
    float yi = _radius * sin(radians(i*dTheta+Theta0)) + _y0;
    float xf = _radius * cos(radians((i+1)*dTheta+Theta0)) + _x0;
    float yf = _radius * sin(radians((i+1)*dTheta+Theta0)) + _y0;

    vertex(xi,yi, 0);
    vertex(xf,yf, 0);
  }
  endShape();
  noStroke();
}


//==============================
//   KEY PRESSED
//==============================
void keyPressed() {
  //--- Zoom
  switch(key) {
  case 's':
    saveFrame("sh-####.png");
    break;
  }
}

